﻿init python:
    import pygame
    import random
    import time
    random.seed(time.clock())
    class block:
        def __init__(self, name, image, x = 0, y = 0, hardness = 0):
            self.name = name
            self.image = image
            self.x = x
            self.y = y
            self.health = 10
            self.hardness = hardness
        def dig(self, map):
            self.health -= 1
            if self.health < 1:
                map.map.remove(self)
                for n,i in enumerate(map.materials):
                    if i[0] == self.name:
                        map.materials[n][1] += 1
            else:
                renpy.play("miner/punch.ogg", "sound")
            renpy.restart_interaction()

    class mine_handler:
        def __init__(self):
            self.materials = [
                ["Dirt", 0, 0, 60],
                # ["Stone", 0, 2, 40],
                ["Coal", 0, 1, 20],
                ["Garnet", 0, 3, 8],
                ["Gold", 0, 4, 4],
                ["Diamond", 0, 5, 2],
            ]

            total_chance = 0
            for i in self.materials:
                total_chance += i[3]
            
            self.map = []
            for i in range(-10, 11):
                for j in range(-7, 8):
                    if not(i in [-1,0,1] and j in [-1,0,1]):
                        chance = random.randint(0, total_chance+10)
                        total = 0
                        for o in self.materials:
                            total += o[3]
                            if chance < total:
                                b = block(o[0], o[0].lower(), i, j, o[2])
                                self.map.append(b)
                                break

            self.x = 0
            self.y = 0
        def dig(self):
            pass

    class player_sprite(renpy.Displayable):
        def __init__(self, image, map):
            super(renpy.Displayable,self).__init__()
            self.start_image = image
            self.go_left = 0
            self.go_right = 0
            self.go_up = 0
            self.go_down = 0
            self.x = 0
            self.y = 0
            self.speed = 1.0
            self.facing = 1
            self.frame = 4
            self.max_frames = 3
            self.y_velocity = 0
            self.map = map
            self.pause = 0
        def animate(self):
            if self.frame == 5:
                self.frame = 4
                renpy.redraw(self, 0)
            else:
                self.frame += 1
                if self.frame > self.max_frames:
                    self.frame = 0


        def attack(self, blocks):
            self.frame = 5
            renpy.redraw(self, 0)
            hit = False
            for i in blocks:
                if distance(self.x, i.x*16) < 16:
                    msg.msg("1")
                    if distance(self.y, i.y*16) < 24:
                        msg.msg("2")
                        i.damage()
                        hit = True
                        break
            if hit:
                renpy.play("holding/punch.ogg", "sound")
            else:
                renpy.play("holding/miss.ogg", "sound")

        def render(self,width,height,st,at):
            if self.pause < 1:
                self.x += (self.go_left+self.go_right)*self.speed
                self.y += (self.go_up+self.go_down)*self.speed
                for i in self.map.map:
                    if distance(self.x, i.x*16) < 12:
                        if distance(self.y, i.y*16) < 12:
                            if self.go_left and self.x > i.x*16:
                                self.x += 5
                            if self.go_right and self.x < i.x*16:
                                self.x -= 5
                            if self.go_up and self.y > i.y*16:
                                self.y += 5
                            if self.go_down and self.y < i.y*16:
                                self.y -= 5
                            i.dig(self.map)
                            self.pause = 10
                            break
            else:
                self.pause -= 1

            img = self.start_image

            t = Transform(img, xanchor=0.5, yanchor=0.5, rotate = self.facing)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x,self.y))

            if self.go_left or self.go_right or self.go_up or self.go_down or self.y < 0:
                renpy.redraw(self, 0)

            return rv

        def event(self, ev, x, y, st):
            if ev.type == pygame.KEYDOWN:
                if ev.key == pygame.K_a:
                    self.facing = -90
                    self.go_left = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

                elif ev.key == pygame.K_d:
                    self.facing = 90
                    self.go_right = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

                if ev.key == pygame.K_w:
                    self.facing = 0
                    self.go_up = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

                elif ev.key == pygame.K_s:
                    self.facing = 180
                    self.go_down = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

            elif ev.type == pygame.KEYUP:
                if ev.key == pygame.K_a:
                    self.go_left = 0
                    self.frame = 4
                    # raise renpy.IgnoreEvent()

                elif ev.key == pygame.K_d:
                    self.go_right = 0
                    self.frame = 4
                    # raise renpy.IgnoreEvent()

                if ev.key == pygame.K_w:
                    self.go_up = 0
                    self.frame = 4
                    # raise renpy.IgnoreEvent()

                elif ev.key == pygame.K_s:
                    self.go_down = 0
                    self.frame = 4
                    # raise renpy.IgnoreEvent()
            return None

init:
    $ config.keymap['screenshot'].append('o')

image damage 1 = Crop((0, 0, 16, 16), "damage_animation")
image damage 2 = Crop((16, 0, 16, 16), "damage_animation")
image damage 3 = Crop((32, 0, 16, 16), "damage_animation")

image damage 4 = Crop((0, 16, 16, 16), "damage_animation")
image damage 5 = Crop((16, 16, 16, 16), "damage_animation")
image damage 6 = Crop((32, 16, 16, 16), "damage_animation")

image damage 7 = Crop((0, 32, 16, 16), "damage_animation")
image damage 8 = Crop((16, 32, 16, 16), "damage_animation")
image damage 9 = Crop((32, 32, 16, 16), "damage_animation")

default mine_map = mine_handler()
default miner = player_sprite("miner_image", mine_map)

screen mine(p = miner, g = mine_map):
    modal True
    key "K_SPACE" action Function(g.dig)
    frame padding 0,0 xysize 336,240 align .0,.0 offset 60,60 background "#fff9":
        for i in g.map:
            fixed fit_first True:
                align .5,.5 xysize 16,16 offset i.x*16,i.y*16
                add i.image
                if i.health < 10:
                    add "damage {}".format(i.health)
        # add "16x16" align .5,.5
        at zoom(4, True)
        add miner:
            align .5,.5
    frame xsize 500 yfill True xalign 1.0 background None:
        vbox align .0,.5:
            for i in g.materials:
                text "{}: {}".format(i[0], i[1])


label miner_example:
    call screen mine